#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "../../include/stri18n.h"

using namespace mcl;

int main(int argc, char *argv[])
{
    char s[128], r[128];
    
    printf("LATIN GREEK TO 737\n");
    strcpy(s, "auta einai latinika ellhnika!");
    translate(s, MCL_CP_LATGREEK, r, MCL_CP_737);
    printf("source string:     [%s]\n", s);
    printf("translated string: [%s]\n", r);
    
    printf("1253 TO 737\n");
    strcpy(s, "    Codepage 1253");
    translate(s, MCL_CP_1253, r, MCL_CP_737);
    printf("source string:     [%s]\n", s);
    printf("translated string: [%s]\n", r);
    printf("%x, %x\n", (unsigned char)s[0], (unsigned char)r[0]);

    printf("TO_UPPER\n");
    strcpy(s, "    Codepage 1253");
    strfunc(s, MCL_CP_1253, to_upper);
    translate(s, MCL_CP_1253, r, MCL_CP_737);
    printf("translated string: [%s]\n", r);

    printf("TO_LOWER\n");
    strcpy(s, "    Codepage 1253");
    strfunc(s, MCL_CP_1253, to_lower);
    translate(s, MCL_CP_1253, r, MCL_CP_737);
    printf("translated string: [%s]\n", r);

    printf("TO_UNACCENT\n");
    strcpy(s, "      Codepage 1253");
    strfunc(r, MCL_CP_1253, to_unaccent);
    translate(s, MCL_CP_1253, r, MCL_CP_737);
    printf("translated string: [%s]\n", r);

    printf("TO_UNACCENT (from upper)\n");
    strcpy(s, "Ԣ ź ʢ м Codepage 1253");
    translate(s, MCL_CP_1253, r, MCL_CP_737);
    strfunc(r, MCL_CP_737, to_unaccent);
    printf("translated string: [%s]\n", r);

    strcpy(s, "    Codepage 1253");
    translate(r, MCL_CP_737, s, MCL_CP_LATGREEK);
    printf("source string:     [%s]\n", r);
    printf("translated string: [%s]\n", s);

    translate(s, MCL_CP_LATGREEK, r, MCL_CP_737);
    printf("source string:     [%s]\n", s);
    printf("translated string: [%s]\n", r);

    strcpy(s, "    Codepage 1253");
    translate(s, MCL_CP_1253, s, MCL_CP_737);
    strcpy(r, s);
    strfunc(r, MCL_CP_737, to_lower);
    int cmp = strxcmp(s, r, MCL_CP_737, to_unaccentupper);
    if (cmp==0) printf("strxcmp: test strings [%s] and [%s] are equal\n", s, r);
    else printf("strxcmp: test strings [%s] and [%s] are NOT equal\n", s, r);

    strcpy(s, "    .    .  ;");
    translate(s, MCL_CP_1253, s, MCL_CP_737);
    printf("test string [%s]\n", s);
    strcpy(r, s);
    strfunc(r, MCL_CP_737, to_upper);
    fixfinal_s(s, MCL_CP_737);
    fixfinal_s(r, MCL_CP_737);
    printf("fixfinal_s: test strings: \n[%s] and \n[%s]\n", s, r);

#ifdef __GNUC__
    system("PAUSE");
#endif

    return 0;
}
